import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * This is a white blood cell. This kind of cell has the job to catch 
 * BlackAsteroid and remove them from the blood.
 * 

 */
public class SpaceShip extends Actor
{
    private int score;
    GreenfootImage img1 = new GreenfootImage("spaceShip.png");
    GreenfootImage img2 = new GreenfootImage("spaceShipv2.png");
    /**
     * http://www.clipartlord.com/category/space-clip-art/spaceship-clip-art/page/2/ 
     */
    public void act() 
    {

        checkKeyPress();
        checkCollision();
        lookForAsteroid();
        checkDebris();
        score = 0;
        checkMouse();
        shoot();
    }

    /**
     * Check whether a keyboard key has been pressed and react if it has.
     */
    private void checkKeyPress()
    {
        if (Greenfoot.isKeyDown("up")) 
        {
            setLocation(getX(), getY()-4);
        }

        if (Greenfoot.isKeyDown("down")) 
        {
            setLocation(getX(), getY()+4);
        }

        if (Greenfoot.isKeyDown("left")) 
        {
            setLocation(getX()-4, getY());
        }

        if (Greenfoot.isKeyDown("right")) 
        {
            setLocation(getX()+4, getY());
        }
    }

    /**
     * the first time you use this, you have to click twice, after this only
     * one click is required
     */
    public void checkMouse()
    {
        if (Greenfoot.mouseClicked(null))
        {
            switchImage();
        }
    }

    public void switchImage()
    {
        if (getImage() == img1) 
        {
            setImage(img2);
        }
        else {
            setImage(img1);
        }
    }

    public void checkCollision()
    {
        if ( isTouching(BlackAsteroid.class) ) 
        {            
            Greenfoot.playSound("break.wav");
            removeTouching(BlackAsteroid.class);
            Space Space = (Space)getWorld();
            Space.addScore(20);
        }
    }

    public void lookForAsteroid()
    {
        if ( isTouching(Asteroid.class) ) 
        {
            Greenfoot.playSound("hit.wav");
            removeTouching(Asteroid.class);
            Space Space = (Space)getWorld();
            Space.addScore(-100);
        }
    }

    /**
     * 
     */

    public void checkDebris()
    {
        Debris debris = (Debris) getOneIntersectingObject(Debris.class);
        if (debris !=null)
        {
            debris.move (4);
        }
    }

    public void shoot()
    {
        if ("space".equals(Greenfoot.getKey()))
        {
            Bullet bullet = new Bullet();
            getWorld().addObject(bullet, getX(), getY());
        }
    }
}
